package sheet6;

/** This class implements a multiplicative linear
congruence generator (LCG)
*
* Methods:
* int intRand() for pseudo-random number z_i
*
* @param m: module
* @param a: factor
* @param z: pseudo-random number (resp. grain)
*
* @author: F. Timmermann, 10.06.2010
* @author: O. Stenzel, 03.07.2012
*/

public class lcg {
		
	/* Initialization of parameters */
	private int z = 1, m = 512, a = 51, c = 0;
	
	/* Constructs a LCG with module, factor, grain and increment*/
	public lcg(int z, int m, int a, int c) {
		this.z = z;
		this.m = m;
		this.a = a;
		this.c = c;
	}
	
	/* Constructs a LCG with module 512, factor 51 and
	grain 1 */
	public lcg() {
	}
	
	/* Recursive calculation of numbers z in {0,...,m-1}
	under mod(m)-rule
	*
	* @return pseudo-random number in {0,...,m-1}
	*/
	public int intRand() {
		z = (a * z + c) % m;
		return z;
	}
	
	/* Transformation of the numbers in {0,...,m-1} in
	interval [0,1)
	*
	* @ return z/m pseudo-random number u in [0,1)
	(uniformly distributed??)
	*/
	public double uniRand() {
		double z = intRand();
		return z / m;
	}

	/* Main program */
	static public void main(String[] args) {
		/* Initialization with fixed parameters */
		lcg mylcg = new lcg();
		/* Prints the first 10 numbers */
		for (int i = 0; i < 10; i++) {
		System.out.println(mylcg.intRand());
		}
	}
}
